Index: .gitignore
===================================================================
--- .gitignore	(revision 1b605fb2e0c1caf11caf0de26137a4e61df878f6)
+++ .gitignore	(revision 153b75a64d88ad8b0597c08dada6ae0ca20c08d1)
@@ -34,9 +34,4 @@
 /docs/sphinx-docs/build
 /docs/sphinx-docs/source-temp
-/docs/sphinx-docs/source/dev/api
-/docs/sphinx-docs/source/user/guiframe
-/docs/sphinx-docs/source/user/models
-/docs/sphinx-docs/source/user/sasview
-/docs/sphinx-docs/source/user/perspectives
 /docs/sphinx-docs/katex*.zip
 /docs/sphinx-docs/node_modules
Index: docs/sasview/.gitignore
===================================================================
--- docs/sasview/.gitignore	(revision 356af60ef4067ec412316b5d0ea7e787955d8487)
+++ docs/sasview/.gitignore	(revision 356af60ef4067ec412316b5d0ea7e787955d8487)
@@ -0,0 +1,1 @@
+/README.txt
Index: docs/sphinx-docs/build_sphinx.py
===================================================================
--- docs/sphinx-docs/build_sphinx.py	(revision df724752143d7fe3872f462fc4837fcb889ebad9)
+++ docs/sphinx-docs/build_sphinx.py	(revision 153b75a64d88ad8b0597c08dada6ae0ca20c08d1)
@@ -8,12 +8,10 @@
 from __future__ import print_function
 
-import subprocess
+import sys
 import os
 from os.path import join as joinpath, abspath, dirname, isdir, exists, relpath
-import sys
-import fnmatch
 import shutil
+import subprocess
 import imp
-
 from glob import glob
 from distutils.dir_util import copy_tree
@@ -21,8 +19,5 @@
 from distutils.spawn import find_executable
 
-from shutil import copy
-from os import listdir
-
-platform = '.%s-%s'%(get_platform(),sys.version[:3])
+PLATFORM = '.%s-%s'%(get_platform(), sys.version[:3])
 
 # sphinx paths
@@ -35,5 +30,5 @@
 SASVIEW_ROOT = joinpath(SPHINX_ROOT, '..', '..')
 SASVIEW_DOCS = joinpath(SPHINX_ROOT, "source")
-SASVIEW_BUILD = abspath(joinpath(SASVIEW_ROOT, "build", "lib"+platform))
+SASVIEW_BUILD = abspath(joinpath(SASVIEW_ROOT, "build", "lib"+PLATFORM))
 SASVIEW_MEDIA_SOURCE = joinpath(SASVIEW_ROOT, "src", "sas")
 SASVIEW_DOC_TARGET = joinpath(SASVIEW_BUILD, "doc")
@@ -65,15 +60,13 @@
 
 def inplace_change(filename, old_string, new_string):
-# Thanks to http://stackoverflow.com/questions/4128144/replace-string-within-file-contents
-        s=open(filename).read()
-        if old_string in s:
-                print('Changing "{old_string}" to "{new_string}"'.format(**locals()))
-                s=s.replace(old_string, new_string)
-                f=open(filename, 'w')
-                f.write(s)
-                f.flush()
-                f.close()
-        else:
-                print('No occurences of "{old_string}" found.'.format(**locals()))
+    # Thanks to http://stackoverflow.com/questions/4128144/replace-string-within-file-contents
+    s = open(filename).read()
+    if old_string in s:
+        print('Changing "{old_string}" to "{new_string}"'.format(**locals()))
+        s = s.replace(old_string, new_string)
+        with open(filename, 'w') as f:
+            f.write(s)
+    else:
+        print('No occurences of "{old_string}" found.'.format(**locals()))
 
 def _remove_dir(dir_path):
@@ -241,6 +234,6 @@
         finally:
             fd_in.close()
-    with ZipFile(cache_path) as zip:
-        zip.extractall(destination)
+    with ZipFile(cache_path) as archive:
+        archive.extractall(destination)
 
 def convert_katex():
Index: docs/sphinx-docs/source/conf.py
===================================================================
--- docs/sphinx-docs/source/conf.py	(revision f1d48e95a251680027bcec129c281bec220c1da0)
+++ docs/sphinx-docs/source/conf.py	(revision b229a3bf14cf52237670dc67090e092cbe9939db)
@@ -11,4 +11,5 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
+from __future__ import print_function
 
 import sys, os, collections
@@ -22,6 +23,6 @@
 sys.path.insert(0, build_lib)
 sys.path.insert(0, os.path.abspath('_extensions')) # for sphinx extensions
-print "-- path --"
-print "\n".join(sys.path)
+print("-- path --")
+print("\n".join(sys.path))
 
 # -- General configuration -----------------------------------------------------
@@ -71,5 +72,5 @@
 # General information about the project.
 project = u'SasView'
-copyright = u'2017, The SasView Project'
+copyright = u'2018, The SasView Project'
 
 # The version info for the project you're documenting, acts as replacement for
Index: docs/sphinx-docs/source/rst_prolog
===================================================================
--- docs/sphinx-docs/source/rst_prolog	(revision 1659f54b83a4ef1858ffda40170e4ea6d4e03ca9)
+++ docs/sphinx-docs/source/rst_prolog	(revision 153b75a64d88ad8b0597c08dada6ae0ca20c08d1)
@@ -1,2 +1,4 @@
+.. TODO: This file is ignored!  Prolog comes from sasmodels/doc/rst_prolog.
+
 .. Set up some substitutions to make life easier...
 
Index: installers/setup_exe.py
===================================================================
--- installers/setup_exe.py	(revision 3da869277e4266d05f07e946b31a29f8ee548ccf)
+++ installers/setup_exe.py	(revision f05f6ff73bd3b17b3e32d3a485feb695e49279f7)
@@ -287,4 +287,5 @@
     'matplotlib', 'scipy', 'encodings', 'comtypes', 'h5py',
     'win32com', 'xhtml2pdf', 'bumps', 'sasmodels', 'sas',
+    'pkg_resources'
     ]
 packages.extend([
Index: src/sas/sascalc/dataloader/readers/abs_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/abs_reader.py	(revision e3775c679a7033e0bd33a9387d5bdfa4fb87bc4b)
+++ src/sas/sascalc/dataloader/readers/abs_reader.py	(revision bd5c3b11a604dfd75fa3d6424e1ea40bcafd3727)
@@ -171,5 +171,5 @@
 
                 try:
-                    _x = float(toks[0])
+                    _x = float(toks[4])
                     _y = float(toks[1])
                     _dy = float(toks[2])
Index: src/sas/sascalc/fit/pagestate.py
===================================================================
--- src/sas/sascalc/fit/pagestate.py	(revision aca687ac38731c5a9ca8a3796ed35af3b9a59be1)
+++ src/sas/sascalc/fit/pagestate.py	(revision 59873e112188eeb053c5c84f0936a10f563da235)
@@ -144,4 +144,5 @@
 ################################################################################
 import time
+import re
 import os
 import sys
@@ -773,4 +774,9 @@
                     name = value.split(':', 1)[1].strip()
                     file_value = "File name:" + name
+                    #Truncating string so print doesn't complain of being outside margins
+                    if sys.platform != "win32":
+                        MAX_STRING_LENGHT = 50
+                        if len(file_value) > MAX_STRING_LENGHT:
+                            file_value = "File name:.."+file_value[-MAX_STRING_LENGHT+10:]
                     file_name = CENTRE % file_value
                     if len(title) == 0:
@@ -848,9 +854,12 @@
         html_str, text_str, title = self._get_report_string()
         # Allow 2 figures to append
-        image_links = [FEET_2%fig for fig in fig_urls]
-
+        #Constraining image width for OSX and linux, so print doesn't complain of being outside margins
+        if sys.platform == "win32":
+            image_links = [FEET_2%fig for fig in fig_urls]
+        else:
+            image_links = [FEET_2_unix%fig for fig in fig_urls]
         # final report html strings
         report_str = html_str + ELINE.join(image_links)
-
+        report_str += FEET_3
         return report_str, text_str
 
@@ -1081,6 +1090,6 @@
         if node.get('version'):
             # Get the version for model conversion purposes
-            self.version = tuple(int(e) for e in
-                                 str.split(node.get('version'), "."))
+            x = re.sub('[^\d.]', '', node.get('version'))
+            self.version = tuple(int(e) for e in str.split(x, "."))
             # The tuple must be at least 3 items long
             while len(self.version) < 3:
@@ -1495,5 +1504,8 @@
 """
 FEET_2 = \
-"""<img src="%s" ></img>
+"""<img src="%s"></img>
+"""
+FEET_2_unix = \
+"""<img src="%s" width="540"></img>
 """
 FEET_3 = \
Index: src/sas/sasgui/guiframe/config.py
===================================================================
--- src/sas/sasgui/guiframe/config.py	(revision 1efbc190a388190d54fbdbcf384110dd991977fe)
+++ src/sas/sasgui/guiframe/config.py	(revision 8ac05a59a0078f40fc8af4febae16624b9d5c818)
@@ -33,4 +33,5 @@
 _do_aboutbox = True
 _do_acknowledge = True
+_do_release = True
 _do_tutorial = True
 _acknowledgement_preamble =\
@@ -49,5 +50,4 @@
 _acknowledgement_citation = \
 '''M. Doucet et al. SasView Version 4.1.2, Zenodo, 10.5281/zenodo.825675'''
-
 _acknowledgement =  \
 '''This work was originally developed as part of the DANSE project funded by the US NSF under Award DMR-0520547,\n but is currently maintained by a collaboration between UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, DLS, and the scattering community.\n\n SasView also contains code developed with funding from the EU Horizon 2020 programme under the SINE2020 project (Grant No 654000).\nA list of individual contributors can be found at: http://www.sasview.org/contact.html
@@ -94,5 +94,5 @@
 _corner_image = os.path.join(icon_path, "angles_flat.png")
 _welcome_image = os.path.join(icon_path, "SVwelcome.png")
-_copyright = "(c) 2009 - 2017, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, and DLS"
+_copyright = "(c) 2009 - 2018, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, and DLS"
 marketplace_url = "http://marketplace.sasview.org/"
 
Index: src/sas/sasgui/guiframe/gui_manager.py
===================================================================
--- src/sas/sasgui/guiframe/gui_manager.py	(revision b963b2066d6a76fe5073000c5a596a6fd0130ac4)
+++ src/sas/sasgui/guiframe/gui_manager.py	(revision 8ac05a59a0078f40fc8af4febae16624b9d5c818)
@@ -1276,11 +1276,24 @@
 
         wx_id = wx.NewId()
-        self._help_menu.Append(wx_id, '&Documentation', '')
+        self._help_menu.Append(wx_id, '&Documentation', 'Help documentation for SasView')
         wx.EVT_MENU(self, wx_id, self._onSphinxDocs)
 
         if config._do_tutorial and (IS_WIN or sys.platform == 'darwin'):
             wx_id = wx.NewId()
-            self._help_menu.Append(wx_id, '&Tutorial', 'Software tutorial')
+            # Pluralised both occurences of 'Tutorial' in the line below
+            # S King, Sep 2018
+            self._help_menu.Append(wx_id, '&Tutorials', 'Tutorials on how to use SasView')
             wx.EVT_MENU(self, wx_id, self._onTutorial)
+
+        if config.marketplace_url:
+            wx_id = wx.NewId()
+            self._help_menu.Append(wx_id, '&Model marketplace', 'Plug-in fitting models for SasView')
+            wx.EVT_MENU(self, wx_id, self._on_marketplace_click)
+
+        if config._do_release:
+            wx_id = wx.NewId()
+            self._help_menu.Append(wx_id, '&Release notes',
+                                   'SasView release notes and known issues')
+            wx.EVT_MENU(self, wx_id, self._onRelease)
 
         if config._do_acknowledge:
@@ -1293,11 +1306,6 @@
             logger.info("Doing help menu")
             wx_id = wx.NewId()
-            self._help_menu.Append(wx_id, '&About', 'Software information')
+            self._help_menu.Append(wx_id, '&About', 'Information about SasView')
             wx.EVT_MENU(self, wx_id, self._onAbout)
-
-        if config.marketplace_url:
-            wx_id = wx.NewId()
-            self._help_menu.Append(wx_id, '&Model marketplace', '')
-            wx.EVT_MENU(self, wx_id, self._on_marketplace_click)
 
         # Checking for updates
@@ -2137,4 +2145,18 @@
             dialog.ShowModal()
 
+    def _onRelease(self, evt):
+        """
+        Pop up the release notes
+
+        :param evt: menu event
+
+        """
+        # S King, Sep 2018
+
+        from documentation_window import DocumentationWindow
+        _TreeLocation = "user/release.html"
+        DocumentationWindow(self, -1, _TreeLocation, "",
+                            "SasView Documentation")
+
     def _onTutorial(self, evt):
         """
@@ -2144,42 +2166,17 @@
 
         """
-        if config._do_tutorial:
-            path = config.TUTORIAL_PATH
-            if IS_WIN:
-                try:
-                    from sas.sasgui.guiframe.pdfview import PDFFrame
-                    dialog = PDFFrame(None, -1, "Tutorial", path)
-                    # put icon
-                    self.put_icon(dialog)
-                    dialog.Show(True)
-                except:
-                    logger.error("Error in _onTutorial: %s" % sys.exc_value)
-                    try:
-                        # Try an alternate method
-                        logger.error(
-                            "Could not open the tutorial pdf, trying xhtml2pdf")
-                        from xhtml2pdf import pisa
-                        pisa.startViewer(path)
-                    except:
-                        logger.error(
-                            "Could not open the tutorial pdf with xhtml2pdf")
-                        msg = "This feature requires 'PDF Viewer'\n"
-                        wx.MessageBox(msg, 'Error')
-            else:
-                try:
-                    command = "open '%s'" % path
-                    os.system(command)
-                except:
-                    try:
-                        # Try an alternate method
-                        logger.error(
-                            "Could not open the tutorial pdf, trying xhtml2pdf")
-                        from xhtml2pdf import pisa
-                        pisa.startViewer(path)
-                    except:
-                        logger.error(
-                            "Could not open the tutorial pdf with xhtml2pdf")
-                        msg = "This feature requires the Preview application\n"
-                        wx.MessageBox(msg, 'Error')
+        # Action changed from that in 2.x/3.x/4.0.x/4.1.x
+        # Help >> Tutorial used to bring up a pdf of the
+        # original 2.x tutorial.
+        # Code below, implemented from 4.2.0, redirects
+        # action to the Tutorials page of the help 
+        # documentation to give access to all available
+        # tutorials
+        # S King, Sep 2018
+
+        from documentation_window import DocumentationWindow
+        _TreeLocation = "user/tutorial.html"
+        DocumentationWindow(self, -1, _TreeLocation, "",
+                            "SasView Documentation")
 
     def _onSphinxDocs(self, evt):
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/parameters_panel_slicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/parameters_panel_slicer.py	(revision a26f67f1457e7e39b79d4c3800c03bcaa208dff7)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/parameters_panel_slicer.py	(revision a20a25573879c0953c15607f10eb7cf47e80c047)
@@ -251,7 +251,17 @@
             self.bck.Add(self.batch_slicer_button, (iy, ix), (1, 1),
                          wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 15)
+            # Help button
+
+            self.bt_help = wx.Button(self, wx.NewId(), "HELP")
+            self.bt_help.SetToolTipString(
+                "Help for the slicer parameters and batch slicing.")
+            self.bck.Add(self.bt_help, (iy, 1), (1, 1),
+                         wx.ALIGN_RIGHT | wx.ADJUST_MINSIZE, 15)
+            wx.EVT_BUTTON(self, self.bt_help.GetId(), self.on_help)
+
             iy += 1
             self.bck.Add((5, 5), (iy, ix), (1, 1),
                          wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 5)
+
         self.bck.Layout()
         self.bck.Fit(self)
@@ -535,2 +545,15 @@
             self.default_value += "_{0}".format(key).split(" [")[0]
             self.default_value += "-{:.2f}".format(params[key])
+
+    def on_help(self, event=None):
+        """
+        Opens a help window for the slicer parameters/batch slicing window
+        :param event:
+        :return:
+        """
+        from sas.sasgui.guiframe.documentation_window import DocumentationWindow
+
+        _TreeLocation = "user/sasgui/guiframe/graph_help.html"
+        _doc_viewer = DocumentationWindow(self, wx.ID_ANY, _TreeLocation,
+                                          "#d-data-averaging",
+                                          "Data Explorer Help")
Index: src/sas/sasgui/guiframe/report_dialog.py
===================================================================
--- src/sas/sasgui/guiframe/report_dialog.py	(revision 69a68979fe94b8f135a602e7f02b162e34616d53)
+++ src/sas/sasgui/guiframe/report_dialog.py	(revision d0ce666faaf0f9284be2e607a0ac846cdd9a682b)
@@ -7,4 +7,5 @@
 import sys
 import wx.html as html
+from sas.sasgui.guiframe.report_image_handler import ReportImageHandler
 
 logger = logging.getLogger(__name__)
@@ -27,5 +28,5 @@
 class BaseReportDialog(wx.Dialog):
 
-    def __init__(self, report_list, *args, **kwds):
+    def __init__(self, report_list, imgRAM, fig_urls, *args, **kwds):
         """
         Initialization. The parameters added to Dialog are:
@@ -37,4 +38,8 @@
         kwds["image"] = 'Dynamic Image'
 
+        #MemoryFSHandle for storing images
+        self.imgRAM = imgRAM
+        #Images location in urls
+        self.fig_urls = fig_urls
         # title
         self.SetTitle("Report")
@@ -66,4 +71,6 @@
         button_close = wx.Button(self, wx.ID_OK, "Close")
         button_close.SetToolTipString("Close this report window.")
+        button_close.Bind(wx.EVT_BUTTON, self.onClose,
+                          id=button_close.GetId())
         hbox.Add(button_close)
         button_close.SetFocus()
@@ -75,8 +82,9 @@
         hbox.Add(button_print)
 
-        button_save = wx.Button(self, wx.NewId(), "Save")
-        button_save.SetToolTipString("Save this report.")
-        button_save.Bind(wx.EVT_BUTTON, self.onSave, id=button_save.GetId())
-        hbox.Add(button_save)
+        if sys.platform != "darwin":
+            button_save = wx.Button(self, wx.NewId(), "Save")
+            button_save.SetToolTipString("Save this report.")
+            button_save.Bind(wx.EVT_BUTTON, self.onSave, id=button_save.GetId())
+            hbox.Add(button_save)
 
         # panel for report page
@@ -111,10 +119,14 @@
         printh.PrintText(self.report_html)
 
-    def OnClose(self, event=None):
+
+    def onClose(self, event=None):
         """
         Close the Dialog
         : event: Close button event
         """
-        self.Close()
+        for fig in self.fig_urls:
+            ReportImageHandler.remove_figure(fig)
+
+        self.Destroy()
 
     def HTML2PDF(self, data, filename):
Index: src/sas/sasgui/guiframe/report_image_handler.py
===================================================================
--- src/sas/sasgui/guiframe/report_image_handler.py	(revision d0ce666faaf0f9284be2e607a0ac846cdd9a682b)
+++ src/sas/sasgui/guiframe/report_image_handler.py	(revision d0ce666faaf0f9284be2e607a0ac846cdd9a682b)
@@ -0,0 +1,81 @@
+import wx
+import logging
+
+logger = logging.getLogger(__name__)
+
+
+class ReportImageHandler:
+    # Singleton class that manages all report plot images
+    # To call the handler, call the static method set_figs
+
+    class _ReportImageHandler:
+
+        def __init__(self):
+            wx.FileSystem.AddHandler(wx.MemoryFSHandler())
+            self.img_holder = wx.MemoryFSHandler()
+            self.refs = {}
+            self.indices = []
+
+        def set_figs(self, figs, bitmaps, perspective):
+            """
+            Save figures and images to memory and return refernces
+            :param figs: A list of matplotlib Figures
+            :param bitmaps: A list of bitmaps
+            :param perspective: A String with the perspective name
+            :return: A tuple of a list of Figures and a list of memory refs
+            """
+            imgs = []
+            refs = []
+            if figs is None or len(figs) == 0:
+                figs = [None]
+            for fig in figs:
+                if fig is not None:
+                    ind = figs.index(fig)
+                    bitmap = bitmaps[ind]
+
+                # name of the fig
+                name = self.create_unique_name(perspective)
+                # AddFile, image can be retrieved with 'memory:filename'
+                ref = 'memory:' + name
+                self.refs[ref] = fig
+                self.img_holder.AddFile(name, bitmap, wx.BITMAP_TYPE_PNG)
+                refs.append(ref)
+                imgs.append(fig)
+            return imgs, refs
+
+        def create_unique_name(self, perspective, index=None):
+            """
+            Create a unique key for each item in memory
+            :param perspective: The perspective name as a string
+            :param index: The base index used for incrementing the name
+            :return: A unique file name not currently in use
+            """
+            if not index:
+                index = len(self.indices)
+            if index in self.indices:
+                name = self.create_unique_name(index + 1)
+            else:
+                self.indices.append(index)
+                name = 'img_{}_{:03d}.png'.format(str(perspective), index)
+            return name
+
+    instance = None
+
+    @staticmethod
+    def check_for_empty_instance():
+        if ReportImageHandler.instance is None:
+            ReportImageHandler.instance = \
+                ReportImageHandler._ReportImageHandler()
+
+    @staticmethod
+    def set_figs(figs, bitmaps, perspective):
+        ReportImageHandler.check_for_empty_instance()
+        return ReportImageHandler.instance.set_figs(figs, bitmaps, perspective)
+
+    @staticmethod
+    def remove_figure(fig_url):
+        try:
+            ReportImageHandler.check_for_empty_instance()
+            ReportImageHandler.instance.refs.pop(fig_url)
+        except Exception as e:
+            logger.warn(e)
Index: src/sas/sasgui/perspectives/calculator/model_editor.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/model_editor.py	(revision c6dfb9f046833f237adda045c26f0ae7a04a6284)
+++ src/sas/sasgui/perspectives/calculator/model_editor.py	(revision 9bf40e7da42d4112c3098b54d9c3b12081500c84)
@@ -43,9 +43,9 @@
 if sys.platform.count("win32") > 0:
     FONT_VARIANT = 0
-    PNL_WIDTH = 450
+    PNL_WIDTH = 500
     PNL_HEIGHT = 320
 else:
     FONT_VARIANT = 1
-    PNL_WIDTH = 590
+    PNL_WIDTH = 500
     PNL_HEIGHT = 350
 M_NAME = 'Model'
@@ -495,16 +495,23 @@
         Choose the equation to use depending on whether we now have
         a sum or multiply model then create the appropriate string
+        
+        for the sum model the result will be:
+        scale_factor * (scale1 * model_1 + scale2 * model_2) + background
+        while for the multiply model it will just be:
+        scale_factor * (model_1* model_2) + background
         """
         name = ''
         if operator == '*':
             name = 'Multi'
-            factor = 'background'
+            factor_1 = ''
+            factor_2 = ''
         else:
             name = 'Sum'
-            factor = 'scale_factor'
+            factor_1 = 'scale_1 * '
+            factor_2 = 'scale_2 * '
 
         self._operator = operator
-        self.explanation = ("  Plugin_model = scale_factor * (model_1 {} "
-            "model_2) + background").format(operator)
+        self.explanation = ("  Plugin_model = scale_factor * ({}model_1 {} "
+            "{}model_2) + background").format(factor_1,operator,factor_2)
         self.explanationctr.SetLabel(self.explanation)
         self.name = name + M_NAME
@@ -663,9 +670,7 @@
         Do the layout for parameter related widgets
         """
-        param_txt = wx.StaticText(self, -1, 'Fit Parameters NOT requiring' + \
-                                  ' polydispersity (if any): ')
-
-        param_tip = "#Set the parameters NOT requiring polydispersity " + \
-        "and their initial values.\n"
+        param_txt = wx.StaticText(self, -1, 'Fit Parameters: ')
+
+        param_tip = "#Set the parameters and their initial values.\n"
         param_tip += "#Example:\n"
         param_tip += "A = 1\nB = 1"
@@ -681,21 +686,4 @@
                                   (self.param_tcl, 1, wx.EXPAND | wx.ALL, 10)])
 
-        # Parameters with polydispersity
-        pd_param_txt = wx.StaticText(self, -1, 'Fit Parameters requiring ' + \
-                                     'polydispersity (if any): ')
-
-        pd_param_tip = "#Set the parameters requiring polydispersity and " + \
-        "their initial values.\n"
-        pd_param_tip += "#Example:\n"
-        pd_param_tip += "C = 2\nD = 2"
-        newid = wx.NewId()
-        self.pd_param_tcl = EditWindow(self, newid, wx.DefaultPosition,
-                                    wx.DefaultSize,
-                                    wx.CLIP_CHILDREN | wx.SUNKEN_BORDER)
-        self.pd_param_tcl.setDisplayLineNumbers(True)
-        self.pd_param_tcl.SetToolTipString(pd_param_tip)
-
-        self.param_sizer.AddMany([(pd_param_txt, 0, wx.LEFT, 10),
-                                  (self.pd_param_tcl, 1, wx.EXPAND | wx.ALL, 10)])
 
     def _layout_function(self):
@@ -899,5 +887,4 @@
             description = self.desc_tcl.GetValue()
             param_str = self.param_tcl.GetText()
-            pd_param_str = self.pd_param_tcl.GetText()
             func_str = self.function_tcl.GetText()
             # No input for the model function
@@ -905,5 +892,5 @@
                 if func_str.count('return') > 0:
                     self.write_file(self.fname, name, description, param_str,
-                                    pd_param_str, func_str)
+                                    func_str)
                     try:
                         result, msg = check_model(self.fname), None
@@ -945,5 +932,5 @@
         self.warning = msg
 
-    def write_file(self, fname, name, desc_str, param_str, pd_param_str, func_str):
+    def write_file(self, fname, name, desc_str, param_str, func_str):
         """
         Write content in file
@@ -952,5 +939,4 @@
         :param desc_str: content of the description strings
         :param param_str: content of params; Strings
-        :param pd_param_str: content of params requiring polydispersity; Strings
         :param func_str: content of func; Strings
         """
@@ -966,5 +952,4 @@
         # Write out parameters
         param_names = []    # to store parameter names
-        pd_params = []
         out_f.write('parameters = [ \n')
         out_f.write('#   ["name", "units", default, [lower, upper], "type", "description"],\n')
@@ -973,12 +958,8 @@
             out_f.write("    ['%s', '', %s, [-inf, inf], '', '%s'],\n"
                         % (pname, pvalue, desc))
-        for pname, pvalue, desc in self.get_param_helper(pd_param_str):
-            param_names.append(pname)
-            pd_params.append(pname)
-            out_f.write("    ['%s', '', %s, [-inf, inf], 'volume', '%s'],\n"
-                        % (pname, pvalue, desc))
         out_f.write('    ]\n')
 
         # Write out function definition
+        out_f.write('\n')
         out_f.write('def Iq(%s):\n' % ', '.join(['x'] + param_names))
         out_f.write('    """Absolute scattering"""\n')
@@ -990,12 +971,7 @@
             out_f.write('    import numpy as np')
         for func_line in func_str.split('\n'):
-            out_f.write('%s%s\n' % (spaces4, func_line))
+            out_f.write('%s%s\n' % ('    ', func_line))
         out_f.write('## uncomment the following if Iq works for vector x\n')
         out_f.write('#Iq.vectorized = True\n')
-
-        # If polydisperse, create place holders for form_volume, ER and VR
-        if pd_params:
-            out_f.write('\n')
-            out_f.write(CUSTOM_TEMPLATE_PD % {'args': ', '.join(pd_params)})
 
         # Create place holder for Iqxy
@@ -1128,29 +1104,4 @@
 description = """%(description)s"""
 
-'''
-
-CUSTOM_TEMPLATE_PD = '''\
-def form_volume(%(args)s):
-    """
-    Volume of the particles used to compute absolute scattering intensity
-    and to weight polydisperse parameter contributions.
-    """
-    return 0.0
-
-def ER(%(args)s):
-    """
-    Effective radius of particles to be used when computing structure factors.
-
-    Input parameters are vectors ranging over the mesh of polydispersity values.
-    """
-    return 0.0
-
-def VR(%(args)s):
-    """
-    Volume ratio of particles to be used when computing structure factors.
-
-    Input parameters are vectors ranging over the mesh of polydispersity values.
-    """
-    return 1.0
 '''
 
Index: src/sas/sasgui/perspectives/calculator/pyconsole.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision 4627657012479a5a97fa088f21eb6a94c0f29f6a)
+++ src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision e2663b7a7ed44d36d60ec897fa92d1309bcf6d8b)
@@ -28,7 +28,39 @@
     Check that the model on the path can run.
     """
+    # TODO: fix model caching
+    # model_test.run_one() is directly forcing a reload of the module, but
+    # sasview_model is caching models that have already been loaded.
+    # If the sasview load happens before the test, then the module is
+    # reloaded out from under it, which causes the global variables in
+    # the model function definitions to be cleared (at least in python 2.7).
+    # To fix the proximal problem of models failing on test, perform the
+    # run_one() tests first.  To fix the deeper problem we should either
+    # remove caching from sasmodels.sasview_model.load_custom_model() or
+    # add caching to sasmodels.custom.load_custom_kernel_module().  Another
+    # option is to add a runTests method to SasviewModel which runs the
+    # test suite directly from the model info structure.  Probably some
+    # combination of options:
+    #    (1) have this function (check_model) operate on a loaded model
+    #    so that caching isn't needed in sasview_models.load_custom_model
+    #    (2) add the runTests method to SasviewModel so that tests can
+    #    be run on a loaded module.
+    #
+    # Also, note that the model test suite runs the equivalent of the
+    # "try running the model" block below, and doesn't need to be run
+    # twice.  The reason for duplicating the block here is to generate
+    # an exception that show_model_output can catch.  Need to write the
+    # runTests method so that it returns success flag as well as output
+    # string so that the extra test is not necessary.
+
+    # check the model's unit tests run
+    from sasmodels.model_test import run_one
+    result = run_one(path)
+
+    # remove cached version of the model, if any
+    from sasmodels import sasview_model
+    sasview_model.MODEL_BY_PATH.pop(path, None)
+
     # try running the model
-    from sasmodels.sasview_model import load_custom_model
-    Model = load_custom_model(path)
+    Model = sasview_model.load_custom_model(path)
     model = Model()
     q =  np.array([0.01, 0.1])
@@ -36,8 +68,4 @@
     qx, qy =  np.array([0.01, 0.01]), np.array([0.1, 0.1])
     Iqxy = model.evalDistribution([qx, qy])
-
-    # check the model's unit tests run
-    from sasmodels.model_test import run_one
-    result = run_one(path)
 
     return result
